/***********************************************************************************************************/
// common.hpp
// Saeed Alaei
/***********************************************************************************************************/

/*!
	\mainpage Lite Libraries

	This is a header only set of libraries that are light weight and independent. 
	Each library is contained in one header file and can be copied and used on its own independently.

	The following is the list of current Lite libraries:
	- \ref xformat
	- \ref array
	- \b signal library
	- \b xml library

	\par Rationale
    The following are the design goals of the lite libraries:
    - Each library should be a single, independent header file that can be copied and included in other 
        projects. They should not depend on anything other than standard C++ libraries. 
    - The syntax should be intuitive and should be what one would expect. 
    - There should be minimal performace overhead.
    - The libraries should be general enough and fully extensibe. The should provide different layers of 
        abstraction and allow for future extentions. 
        If they lack a feature, they should provide the right infrastructure necessary to
        implement that feature as a seamless user extention or as a furture addition to the library.

    \author Saeed Alaei 
    <a href="http://www.google.com/search?hl=en&q=saeed+alaei&btnI=I'm+Feeling+Lucky">(home page)</a>

	\par Copyright
	Permission is hereby granted, free of charge, to any person or organization
	obtaining a copy of the software and accompanying documentation covered by
	this license (the "Software") to use, reproduce, display, distribute,
	execute, and transmit the Software, and to prepare derivative works of the
	Software, and to permit third-parties to whom the Software is furnished to
	do so, all subject to the following:
	\par
	The copyright notices in the Software and this entire statement, including
	the above license grant, this restriction and the following disclaimer,
	must be included in all copies of the Software, in whole or in part, and
	all derivative works of the Software, unless such copies or derivative
	works are solely in the form of machine-executable object code generated by
	a source language processor.
	\par
	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
	SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
	FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
	ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
	DEALINGS IN THE SOFTWARE.
*/
